Redmine - Patch #5035

Migrate from trac - Errors in wiki formating
2010-03-10 14:40 - Mike Stupalov

Status: New Start date: 2010-03-10
Priority: Normal Due date:

Assignee: % Done: 60%
Category: Importers Estimated time: 0.00 hour
Target version:

Description

| have written a patch for a script of migration from Trac.
The list of the brought changes:

. More complete regular expressions in many replacements of formatting wiki pages.
. The first and last name of the user are correctly recognised

. convert [[BRY]] - before all

. Titles correctly converted and only h1. to h6. (Also work for #3910)
. External Links correctly converted (include mailto: links)

. Ticket links correctly converted

. Internal Links correctly converted

. Inline code are converted

. Tables are converted

10. Lists correctly converted (include numbered)

11. Inline images are converted

12. Changed default database adapter to sqlite3
The patch works for audit 3517 and above
The additional information is in remarks. The patch works for r3517 and above.

File: migrate_from_trac_v1.patch

Related issues:
Related to Redmine - Patch #5110: Trac importer improvement patch Closed 2010-03-17

History

#1 - 2010-03-17 22:27 - Bryce Nordgren

This appears to be more comprehensive in terms of wiki formatting fixes than #5110. #5110 adds ticket number mapping on import and Subversion
log message changing.

#2 - 2010-03-19 14:15 - Mike Stupalov

- File migrate_from_trac.rake added

- File migrate_from_trac_v3.patch added

- % Done changed from 60 to 70

Very good. | combined these patches.

For migrate svn, use:

rake redmine:migrate_from_trac_svn RAILS_ENV="production"

out:

WARNING: all commit messages with references to trac pages will be modified
Are you sure you want to continue ? [y/N] y

Subversion repository url []: http://svn.server.dom/project
Subversion repository username []: user

Subversion repository password []: secret
Redmine project identifier []: project-id
https://www.redmine.org/issues/3910
https://www.redmine.org/projects/redmine/repository/svn/revisions/3517
https://www.redmine.org/attachments/3332
https://www.redmine.org/issues/5110
https://www.redmine.org/issues/5110

Also made a few corrections and additions to convert textile format (including previous):
e Convert macro - [TOC]
e Convert source links.
¢ In links recognized quotes and double quotes. (Because Trac supports both types of quotes).

remaining problems of converting the format:

¢ before and after the tables have to add blank lines. (Trac supports a table without the initial and final blank line, and Redmine - no)
e text within the code should be left as is. (now converted to all, including the code.)

Patch: migrate_from_trac_v3.patch
File: migrate from_trac.rake

#3 - 2010-03-21 00:17 - Bryce Nordgren
Hi Mike,
| closed #5110 as resolved because you incorporated it here. | did some more issue triage over on the forums. There were open issues related to

multibyte characters, header imports, "special links", and importing ticket keywords. | also included a "dependency graph" of sorts, indicating which
issues tried to address problems raised in which other issues.

I'm new to Ruby, so | constrained myself to highlighting the main issues. I'd be grateful if you took a look. If everything on that page is addressed by
your patch, | think a whole slew of issues could be closed when #5035 is.

Check out: http://www.redmine.org/boards/1/topics/12273

Thanks for your work!

#4 - 2010-03-22 15:08 - Mike Stupalov
- File migrate_from_trac.rake added

- File migrate_from_trac_v4.patch added

Updated version.
Changes:

e completely fixed bugs #3910

e small fixes conversion links.

e added conversion attachments links (ex. [attachment:file.txt]). Closes #2146
® importing Trac keywords (include corrected patch from #2504)

Patch: migrate from_trac_v4.patch
File: migrate from_trac.rake

#5 - 2010-03-23 15:44 - Mike Stupalov

- File migrate_from_trac_v5.patch added

| founded and fix some new issues:

1. Not converted an attachments in non-latin filename encoding.
o Trac encodes the filenames in hexadecimal number using uppercase letters.
o For the wiki pages also need to encode the subdirectory.

2."Issue categories" not converted "Assigned to" user.

3. If specify the "Target project identifier" with a capital letter, then the error occurred.

Patch: migrate_from_trac_v5.patch

While no changes are made to the main repository, | made a fork of the file migrate_from_trac.rake here:
http://github.com/landy2005/Redmine-migrate-from-Trac

P.S. All the changes | check on 3 big projects that we want to migrate from Trac.
#6 - 2010-03-25 14:47 - Mike Stupalov

| update migrate_from_trac.rake

Changes:

e Changed progress meter to a simple progress bar.
¢ Moved requires for task ":migrate_from_trac_svn' to own module.

See latest version here: http://github.com/landy2005/Redmine-migrate-from-Trac
https://www.redmine.org/attachments/3408
https://www.redmine.org/attachments/3631
https://www.redmine.org/issues/5110
https://www.redmine.org/issues/5035
http://www.redmine.org/boards/1/topics/12273
https://www.redmine.org/issues/3910
https://www.redmine.org/issues/2146
https://www.redmine.org/issues/2504
https://www.redmine.org/attachments/3425
https://www.redmine.org/attachments/3631
https://www.redmine.org/attachments/3440
http://github.com/landy2005/Redmine-migrate-from-Trac
http://github.com/landy2005/Redmine-migrate-from-Trac

#7 - 2010-03-26 19:13 - Bryce Nordgren
Hi Mike,

Still watching your progress and appreciate all your work. I'm actually delaying the migration of our repositories until your improvements are finalized.

)

Thanks again!

#8 - 2010-04-28 17:56 - Bryce Nordgren

- File migrate_from_trac.rake added

- % Done changed from 70 to 90

Hi Mike. I'm starting to use this (the version on github) to migrate our collection of Trac instances over to a new server. Great job! :)

| did have to add "PageTemplates" to the list of Trac pages to discard. | also commented out the part that creates a wiki page for every milestone.

I'm bumping this to 90% done just because | think the only thing left to do is have the admins integrate it with the main code base. | can verify that it
works with my redmine, which was built from trunk on April 26, 2010.

#9 - 2010-04-28 18:02 - Bryce Nordgren

| know there are too many files named the same thing. This migrate from_trac.rake is the version from github that | used. It has "PageTemplates"
added, but it will still create a wiki page for every milestone.

#10 - 2010-04-29 08:27 - Mike Stupalov

OK, | also add "PageTemplates" to the list of Trac pages to discard. :)
But | do not understand what you propose to do with milestone? In your code, no changes associated with it.

In addition, | discovered another problem. The script does not convert the CC list to watchers. I'm working on correcting this.

#11 - 2010-04-30 14:30 - Bryce Nordgren

Well, in the version | uploaded, | didn't change the milestone part. In the version | used to migrate my trac instances, | commented out the 6 lines that
create a wiki page for every milestone. Basically | did this because | have no use for a wiki page with the milestone text on it. The "version" page (with
the same text) serves my purposes.

However, | didn't consider that to be an "error", just my personal preference, so | didn't change the code for that part.

Sorry for the confusion.

#12 - 2010-04-30 14:39 - Bryce Nordgren

One thing | did find is that when | converted trac instances where we never bothered to make a personal page (e.g., first name, last name, email), the
script now assigns all tickets to Redmine Admin. As a matter of fact, I'm finding that converting trac instances with properly defined users causes the
conversion script to create many unwanted accounts. This is mostly because, at the same time I'm switching from Trac to Redmine, I'm also switching
from authenticating off of htpasswd accounts to the corporate Active Directory. | find myself locking the accounts which were created during the
conversion process, but which can never be used again due to the conversion.

#13 - 2010-08-11 16:26 - Michalis Miatidis

Everything OK except:

1) Requires merge with Patch #5764 to work with TRAC 0.12

2) At my local installation, migrated everything apart from users with Firstname of single world and Lastname as null.
#14 - 2010-10-14 17:04 - patrick Sherman

Hi,

This rake works perfectly with tickets but not with the wiki.

It stop conversion at the first accent and links with another page are lost.
What should | need to do?

Regards

#15 - 2010-10-15 12:04 - Alexander Sapozhnikov
redmine:migrate_from_trac_svn doesn't work. First time | got message:

Could not find issue custom field 'TracID'
http://www.redmine.org/attachments/3631/migrate_from_trac.rake
https://www.redmine.org/issues/5764

| add custom field TraclD and got new error:

wrong number of arguments (7 for 4)

When spawned with --trace both on Redmine 0.9.6 and on 1.0.2 too:

path/to/redmine/lib/tasks/migrate_from_trac.
path/to/redmine/lib/tasks/migrate_from_trac.
path/to/redmine/lib/tasks/migrate_from_trac.
path/to/redmine/lib/tasks/migrate_from_trac.
path/to/redmine/lib/tasks/migrate_from_trac.

#16 - 2010-10-15 12:10 - Alexander Sapozhnikov
Line 910 is:

@scm | |= SvnExtendedAdapter.new @@svn_url,

| remove hide 3 last arguments, but see same error.

#17 - 2010-10-15 12:57 - Alexander Sapozhnikov

redmine:migrate_from_trac works, but acts as described in #6632 — it ignore fields Ift, rgt and root_id in table issues.

#18 - 2010-10-16 09:14 - Mike Stupalov

rake:
rake:
rake:
rake:
rake:

- Assignee changed from Jean-Philippe Lang to Felix Schéfer

- % Done changed from 90 to 60

All many thanks for the found errors.

910:
910:
910:
873:

935

@@svn_url,

in “new'

in “scm'

in “initialize’

in ‘migrate'

@@svn_username, @@svn_password,

Unfortunately the main developers redmine don't give attention to a script of migration from trac.

OI

nn
’

nil

I will try to look at the arisen errors. But in connection with study at me hasn't enough time, therefore fast correction | do not promise :)I will try to look

at the arisen errors. But in connection with study at me hasn't enough time, therefore fast correction | do not promise :)

Please send more version informations trac, what database is used, a debug output of a script and certainly a command output:

RAILS_ENV="production" script/about

#19 - 2010-10-16 20:29 - Felix Schafer
- Assignee deleted (Felix Schéfer)

Please don't assign issues to anyone who hasn't said to do so, thanks.

#20 - 2010-11-13 04:54 - Michat Wrébel

| made some patches which improve TracWiki conversion.

Files

migrate_from_trac_v1.patch
migrate_from_trac.rake
migrate_from_trac_v3.patch
migrate_from_trac.rake
migrate_from_trac_v4.patch
migrate_from_trac_v5.patch

migrate_from_trac.rake

2025-05-17

6.33 KB

40 KB
23.7 KB
41.6 KB
25.9 KB
27.5 KB
45.8 KB

2010-03-10
2010-03-19
2010-03-19
2010-03-22
2010-03-22
2010-03-23
2010-04-28

Mike Stupalov
Mike Stupalov
Mike Stupalov
Mike Stupalov
Mike Stupalov
Mike Stupalov
Bryce Nordgren
